/*-------------------------------------------------------------------------

							

    
-------------------------------------------------------------------------*/

#include "bsp.h"
#include "App.h"
#include "Api.h"



static OS_TCB taskStartTCB;
static CPU_STK taskStartStk[STARTUP_TASK_STK_SIZE];     //ĳռ

static OS_TCB taskLedTCB;
static CPU_STK taskLedStk[TASK1_STK_SIZE];

OS_TCB taskFlashTCB;
static CPU_STK taskFlashStk[TASK2_STK_SIZE];

static OS_TCB taskModbusTCB;
static CPU_STK taskModbusStk[TASK3_STK_SIZE];

static char memBuff[2][1040];                           //õڴ

OS_MEM      osMem;

/*******************************************************************************
* Function Name :void TaskStart(void)
* Description   :
* Input         :
* Output        :
* Other         :
* Date          :2012.04.18  11:48:23
*******************************************************************************/
static void TaskStart(void)
{
    OS_ERR 		err;
    
    led_init();
    SysTickInit();
    DriverInit();
    OSMemCreate(    (OS_MEM     *)&osMem, 
                    (CPU_CHAR   *)"ڴ浥Ԫ", 
                    (void       *)memBuff, 
                    (OS_MEM_QTY)API_COUNTOF(memBuff),       //ڴ浥Ԫ
                    (OS_MEM_SIZE)sizeof(memBuff[0]),        //ÿӽ
                    (OS_ERR     *)&err);
    
    OSTaskCreate(   (OS_TCB     *)&taskLedTCB,
                    (CPU_CHAR   *)"OSLedServe",
                    (OS_TASK_PTR)OSLedServe,
                    (void       *)0,
                    (OS_PRIO    )TASK1_PRIO,
                    (CPU_STK    *)&taskLedStk[0],
                    (CPU_STK_SIZE)TASK1_STK_SIZE / 10,
                    (CPU_STK_SIZE)TASK1_STK_SIZE,
                    (OS_MSG_QTY )0,
                    (OS_TICK    )0,
                    (void       *)0,
                    (OS_OPT     )(OS_OPT_TASK_STK_CHK | OS_OPT_TASK_STK_CLR), 
                    (OS_ERR     *)&err);
    
    OSTaskCreate(   (OS_TCB     *)&taskFlashTCB,
                    (CPU_CHAR   *)"Flash Ctrl",
                    (OS_TASK_PTR)OSFlashServe,
                    (void       *)0,
                    (OS_PRIO    ) TASK2_PRIO,
                    (CPU_STK    *)&taskFlashStk[0],
                    (CPU_STK_SIZE)TASK2_STK_SIZE / 10,
                    (CPU_STK_SIZE)TASK2_STK_SIZE,
                    (OS_MSG_QTY )2,
                    (OS_TICK    )0,
                    (void       *)0,
                    (OS_OPT     )(OS_OPT_TASK_STK_CHK | OS_OPT_TASK_STK_CLR), 
                    (OS_ERR     *)&err);	
    
    
    OSTaskCreate(   (OS_TCB     *)&taskModbusTCB,
                    (CPU_CHAR   *)"modbusЭ",
                    (OS_TASK_PTR)OSModbusServe,
                    (void       *)0,
                    (OS_PRIO    )TASK3_PRIO,
                    (CPU_STK    *)&taskModbusStk[0],
                    (CPU_STK_SIZE)TASK3_STK_SIZE / 10,
                    (CPU_STK_SIZE)TASK3_STK_SIZE,
                    (OS_MSG_QTY )0,
                    (OS_TICK    )0,
                    (void       *)0,
                    (OS_OPT     )(OS_OPT_TASK_STK_CHK | OS_OPT_TASK_STK_CLR), 
                    (OS_ERR     *)&err);
    
    
    OSTaskDel(      (OS_TCB     *)&taskStartTCB, 
                    (OS_ERR     *)&err);
}

static void OSLedServe(void *p_arg)
{
    OS_ERR err;
    
    while (1)
    {
        led_on(LED_4);
        OSTimeDly(  (OS_TICK    )200, 
                    (OS_OPT     )OS_OPT_TIME_DLY, 
                    (OS_ERR     *)&err);
        
        led_off(LED_4);
        OSTimeDly(  (OS_TICK    )200, 
                    (OS_OPT     )OS_OPT_TIME_DLY, 
                    (OS_ERR     *)&err);
    }
}




void KernelMain(void)
{
    OS_ERR err;

    CPU_Init();
    OSInit(         (OS_ERR	    *)&err);

    OSTaskCreate(   (OS_TCB     *)&taskStartTCB,
                    (CPU_CHAR   *)"Task Start",
                    (OS_TASK_PTR)TaskStart,
                    (void       *)0,
                    (OS_PRIO    ) STARTUP_TASK_PRIO,
                    (CPU_STK    *)&taskStartStk[0],
                    (CPU_STK_SIZE)STARTUP_TASK_STK_SIZE / 10,
                    (CPU_STK_SIZE)STARTUP_TASK_STK_SIZE,
                    (OS_MSG_QTY )0,
                    (OS_TICK    )0,
                    (void       *)0,
                    (OS_OPT     )(OS_OPT_TASK_STK_CHK | OS_OPT_TASK_STK_CLR), 
                    (OS_ERR     *)&err);    
    
    OSStart(        (OS_ERR	    *)&err);
}





