/*
********************************************************************************
*                                  uC/OS-III
*							
*                              ARM Cortex-M3 Port
*
* File      	: Config.C
* Version   	: V1.0
* By        	: ǿ
*
* For       	: Stm32f10x
* Mode      	: Thumb2
* Toolchain 	: 
*             		RealView Microcontroller Development Kit (MDK)
*             		Keil uVision
* Description   : STM32F10x ڲ ϵͳ
*
*					1ϵͳжȼģʽ
*					2ϵͳָ
*					3ϵͳʱӼʱ
*					4оƬųʼ
*					
* Date          : 2012.05.22
*******************************************************************************/

#include "misc.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_iwdg.h"
#include "bsp.h"


GPIO_InitTypeDef GPIO_InitStructure;

/*******************************************************************************
* Function Name  : GPIO_Configuration
* Description    : Configures the different GPIO ports.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void GPIO_Configuration(void)
{
#ifdef USE_STM3210B_EVAL
	/* Enable the USART2 Pins Software Remapping */
	GPIO_PinRemapConfig(GPIO_Remap_USART2, ENABLE);
#endif

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB |
                     RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD |
                     RCC_APB2Periph_GPIOE, ENABLE);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_Init(GPIOC, &GPIO_InitStructure);
	GPIO_Init(GPIOD, &GPIO_InitStructure);
	GPIO_Init(GPIOE, &GPIO_InitStructure);

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB |
	                     RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD |
	                     RCC_APB2Periph_GPIOE, DISABLE);  

}


/*******************************************************************************
* Function Name  : Delay
* Description    : Inserts a delay time.
* Input          : nCount: specifies the delay time length.
* Output         : None
* Return         : None
*******************************************************************************/
void Delay(volatile CPU_INT32U nCount)
{
  for(; nCount != 0; nCount--);
}

/*******************************************************************************
  void IWDG_Init(void)
Źʼ						
ڲ							
ز
ʱ: 2011.6.24
********************************************************************************/
void IWDG_Init(void)
{
	IWDG_WriteAccessCmd( IWDG_WriteAccess_Enable );
	IWDG_SetPrescaler( IWDG_Prescaler_64);	//С
	IWDG_SetReload( 0x138);		//40KHzڲʱ (1/40000 * 64 * 0x138 = 0.5s)
	IWDG_WriteAccessCmd( IWDG_WriteAccess_Disable );
	IWDG_Enable();
	IWDG_ReloadCounter();
}

/*******************************************************************************
* Function Name :void SysTickInit(void)
* Description   :ϵͳʱʱ
* Input         :
* Output        :
* Other         :ʱΪ1ms
* Date          :2011.11.03  12:59:13
*******************************************************************************/
void SysTickInit(void)
{
	SysTick_Config(SystemCoreClock / 1000);			//uCOSʱ1ms
}

/*******************************************************************************
* Function Name :void InterruptOrder(void)
* Description   :жȼ
* Input         :
* Output        :
* Other         :
* Date          :2011.10.27  11:50:05
*******************************************************************************/
void NVIC_Configuration(void)
{
	NVIC_PriorityGroupConfig( NVIC_PriorityGroup_4);//ȼ  ȫΪռʽȼ
}


/*******************************************************************************
* Function Name :void SystemConfig(void)
* Description   :ϵͳʱ ʼ
* Input         :
* Output        :
* Other         :
* Date          :2012.6.15  13:14:59
*******************************************************************************/
#if (CPU_CFG_TS_TMR_EN == DEF_ENABLED)
void  CPU_TS_TmrInit (void)
{
}
#endif


/*******************************************************************************
* Function Name :void SystemConfig(void)
* Description   :ʱ ֵ
* Input         :ļֵ
* Output        :
* Other         :
* Date          :2012.6.15  13:14:59
*******************************************************************************/
#if (CPU_CFG_TS_TMR_EN == DEF_ENABLED)
CPU_TS_TMR  CPU_TS_TmrRd (void)
{
    return (SysTick->VAL);
}
#endif

/*******************************************************************************
* Function Name :void SystemConfig(void)
* Description   :ϵͳʼ
* Input         :
* Output        :
* Other         :
* Date          :2011.10.27  13:14:59
*******************************************************************************/
void BspInit(void)
{
	NVIC_Configuration();	//жȼ
	GPIO_Configuration();	//˿ڳʼж˿ڹ
}

void led_init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOF, ENABLE);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11 ;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_7 | GPIO_Pin_8 | GPIO_Pin_9;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_Init(GPIOF, &GPIO_InitStructure);
}



void led_on(CPU_INT32U n)
{
	switch (n)
	{
		case LED_0:
		GPIO_SetBits(GPIOA, GPIO_Pin_11);
		break;
		case LED_1:
		GPIO_SetBits(GPIOA, GPIO_Pin_11);
		break;
		case LED_2:
		GPIO_SetBits(GPIOF, GPIO_Pin_6);
		break;
		case LED_3:
		GPIO_SetBits(GPIOF, GPIO_Pin_7);
		break;
		case LED_4:
		GPIO_SetBits(GPIOF, GPIO_Pin_8);
		break;
		case LED_5:
		GPIO_SetBits(GPIOF, GPIO_Pin_9);
		break;
		default:
		break;
	}
}


void led_off(CPU_INT32U n)
{
	switch (n)
	{
		case LED_0:
		GPIO_ResetBits(GPIOA, GPIO_Pin_11);
		break;
		case LED_1:
		GPIO_ResetBits(GPIOA, GPIO_Pin_1);
		break;
		case LED_2:
		GPIO_ResetBits(GPIOF, GPIO_Pin_6);
		break;
		case LED_3:
		GPIO_ResetBits(GPIOF, GPIO_Pin_7);
		break;
		case LED_4:
		GPIO_ResetBits(GPIOF, GPIO_Pin_8);
		break;
		case LED_5:
		GPIO_ResetBits(GPIOF, GPIO_Pin_9);
		break;
		default:
		break;
	}
}





