/*
********************************************************************************
*                                  uC/OS-III
*								 ӿڲ
*                              ARM Cortex-M3 Port
*
* File      : DRIVER.C
* Version   : V1.0
* By        : ǿ
*
* For       : Cortex-M3
* Mode      : Thumb2
* Toolchain : 
*             RealView Microcontroller Development Kit (MDK)
*             Keil uVision
************************************
* Version   : V2.0
* ޸  :   2012.11.8
*           1,ӿڽṹиĽ(ԳԱþ);
*           2,Ӵ־;
*           3,ʣuCos¡
************************************
* Version   : V2.1
* ޸  :   2013.1.1
*           1, ע ʼ DriverInit()
********************************************************************************
*/



#include "Api.h"


/******************************************************************************/
//б
//׵ԪΪЧӵڶԪΪ װ
//
static UDFFrameworkType UdfFramework[DEV_COUNT] = 
{
    UDFFrameworkDefault(),
};

#ifdef MODBUS
static INT8U mbBuffter[2080];

static SLAVE_INFORMATION comParam = {
    100,        //ַ
    0,          //·Э
    576,       // = baud * 100
    0,          //żЧ
    1,          //ֹͣλ
    mbBuffter,     //׵ַ
};

#endif

/*******************************************************************************
* Function Name :void InitDriver(void)
* Description   :ע
* Other         :
* Date          :2013.01.01 
*******************************************************************************/
void DriverInit(void)
{

    extern int Usart1Install(UDFOperationsType *);
//    extern int Usart2Install(UDFOperationsType *);
//    extern int Usart3Install(UDFOperationsType *);
//    extern int SPI2Install(UDFOperationsType *);  


    InstallDriver(ID_USART1, DEV_char, DEV_unShare, Usart1Install);
//    InstallDriver(ID_USART2, DEV_char, DEV_unShare, Usart2Install);
//    InstallDriver(ID_USART3, DEV_char, DEV_unShare, Usart3Install);
//    InstallDriver(ID_SPI2, DEV_char, DEV_unShare, SPI2Install);

#ifdef MODBUS
    MBSlaveIni(&comParam);
    MBTimersInit(&comParam);
#endif

}


/*******************************************************************************
* Function Name :UDFOpen
* Description   :װ豸
* Output        :豸
* Date          :2012.04.27  10:11:44
*******************************************************************************/
DEV_Handle UDFOpen(     DEV_ID      ID,             //豸
                        void        *pd,            //豸޲ΪNULL
    					DEV_ERR     *err)
{
	DEV_Handle hDev = 0;

    if (ID <= ID_EMPTY)
        return HVL_NO_INVALID;

    if (ID >= ID_MAX_NUM)
        return HVL_NO_INVALID;
    
	API_LOCK();
	for (hDev = 1; hDev < DEV_COUNT; hDev++)
	{
		if (ID == UdfFramework[hDev].deviceID) 
		    break;	//ҵ豸
	}

	if (hDev < DEV_COUNT)  			//ҵ豸
	{
		if (UdfFramework[hDev].openCount > 0)	//豸Ծ
		{
			if (UdfFramework[hDev].canShared != DEV_share)	//豸ɹ
			{
				*err = HVL_NO_SHARED;
				hDev = 0;
			}
			else
			{
				UdfFramework[hDev].openCount++;
				*err = HVL_NO_ERR;
			}
		}
		else
		{
			if (UdfFramework[hDev].op.devOpen == NULL)
			{
			    *err = HVL_DRV_OPEN_NULL;
			    hDev = 0;
			}
			else
			{
			    UdfFramework[hDev].openCount = 1;			    
    			*err = (DEV_ERR)(*UdfFramework[hDev].op.devOpen)(pd);
			}
		}	
	}
	else
	{
		*err = HVL_NO_FIN_DEV;
		hDev = 0;
	}
    API_UNLOCK();
    
	return hDev;
}


/*******************************************************************************
* Function Name :UDFRead
* Description   :豸 
* Output        :ϴ
* Date          :2012.04.27  17:16:32
*******************************************************************************/
DEV_ERR UDFRead(        DEV_Handle  hDev,       //豸
    					INT8S       *buffer,    //׵ַ
    					INT32U      blen,       //
    					INT32U      lenToRead, 	//ȡ
    					INT8U       type)       // ݾ
{
    DEV_ERR err;
    FunRead *pFunRead;
    
    if (hDev <= 0)      //жϲIDǷϷ
        return HVL_NO_INVALID;    
        
    if (hDev >= DEV_COUNT)
        return HVL_NO_HANDLE;   
        
    if ( lenToRead > blen)
        return DRV_READ_BOUNDS;

    API_LOCK();
    pFunRead = UdfFramework[hDev].op.devRead;
    if (pFunRead == NULL)
        err = HVL_DRV_READ_NULL;
    else
        err = (DEV_ERR)(*pFunRead)(buffer, blen, lenToRead, type);	
    API_UNLOCK();
    
    return err;
}


/*******************************************************************************
* Function Name :UDFWrite
* Description   :豸д
* Output        :ϴ
* Date          :2012.04.27  17:27:57
*******************************************************************************/
DEV_ERR UDFWrite(       DEV_Handle  hDev,           //豸
    					INT8S       *buffer, 		//
    					INT32U      lenToWrite, 	//д볤
    					INT8U       type)			// ݾ
{
    DEV_ERR err;
    FunWrite *pFunWr;
    
    if (hDev <= 0)      //жϲIDǷϷ
        return HVL_NO_INVALID;    
        
    if (hDev >= DEV_COUNT)
        return HVL_NO_HANDLE;

    API_LOCK();
    pFunWr = UdfFramework[hDev].op.devWrite;
    if (pFunWr == NULL)
        err = HVL_DRV_WRITE_NULL;
    else
        err = (DEV_ERR)(*pFunWr)(buffer, lenToWrite, type);
    API_UNLOCK();

    return err;
}


/*******************************************************************************
* Function Name :INT32S UDFCtrl(INT32U ID, INT32U too, void *pd)
* Description   :ģ
* Input         :	ID:,
					too:豸ƴ롣ο궨DEV_CTRL_XXX Ӧע
					*pd:ѡ豸룬ӦͬĲ οļ
* Output        :
* Date          :2012.04.27  17:29:51
*******************************************************************************/
DEV_ERR UDFCtrl(    DEV_Handle  hDev, 		//豸
					INT32U      too, 		//豸  
					void        *pd	)		//Ʋ οļ
{
    DEV_ERR err;
    FunIoctl *pFunCtrl;

    if (hDev <= 0)      //жϲIDǷϷ
        return HVL_NO_INVALID;    
        
    if (hDev >= DEV_COUNT)
        return HVL_NO_HANDLE;

    API_LOCK();
    pFunCtrl = UdfFramework[hDev].op.devIoctl;
    if (pFunCtrl == NULL)
        err = HVL_DRV_CTRL_NULL;
    else
        err = (DEV_ERR)(*pFunCtrl)(too, pd);
    API_UNLOCK();        

    return err;
}

/*******************************************************************************
* Function Name :INT32S UDFClose(INT32U ID, void *pd)
* Description   :ر豸
* Input         :pd:.
* Output        :
* Date          :2012.04.28  10:33:56
*******************************************************************************/
DEV_ERR UDFClose(       DEV_Handle  hDev) 		//豸
{   
    DEV_ERR err;
    FunClose *pFunClose;

    if (hDev <= 0)      //жϲIDǷϷ
        return HVL_NO_INVALID;    
        
    if (hDev >= DEV_COUNT)
        return HVL_NO_HANDLE;

    API_LOCK();
    pFunClose = UdfFramework[hDev].op.devClose;
    
    if (pFunClose == NULL)
    {
        err = HVL_DRV_CLOSE_NULL;
    }
    else
    {
        UdfFramework[hDev].openCount--;
        if (UdfFramework[hDev].openCount > 0)
            err = HVL_CLOSE;
        else
            err = (DEV_ERR)(*pFunClose)(NULL);
    }
    API_UNLOCK();    
    
    return err;
}

/*******************************************************************************
* Function Name :InstallDriver
* Description   :װ豸
* Output        :
* Date          :2012.05.11  16:17:12
*******************************************************************************/
DEV_ERR InstallDriver(	DEV_ID              ID,             //豸
						DEV_Type            type,           //0-豸1-ַ豸
						DEV_ShareStatus     shared,         //0-ɹ1-ɹ
						FunInstall          *devInstall)	//豸б
{
    DEV_ERR err;
    volatile DEV_Handle hDev;
    
    if (ID < ID_EMPTY)
        return HVL_NO_INVALID;

    if (ID >= ID_MAX_NUM)
        return HVL_NO_INVALID;

    if (devInstall == NULL)
        return HVL_DRV_INSTALL_NULL;

    APIInit();

    API_LOCK();
    for (hDev = 1; hDev < DEV_COUNT; hDev++)        //Ѱδעռ
    {
        if ((UdfFramework[hDev].deviceID == 0) || (UdfFramework[hDev].deviceID == ID_EMPTY))
            break;
    }

    if (hDev >= DEV_COUNT)
        err = HVL_DRV_INSTALL_LIST_FULL;
    else
    {
        UdfFramework[hDev].deviceID = ID;
        UdfFramework[hDev].deviceType = type;
        UdfFramework[hDev].canShared = shared;
        err = (DEV_ERR)(*devInstall)(&UdfFramework[hDev].op);
    }
    API_UNLOCK();
        	
	return err;
}

/*******************************************************************************
* Function Name :UninstallDriver
* Description   :ж豸
* Output        :
* Date          :2012.05.11  17:36:49
*******************************************************************************/
DEV_ERR UninstallDriver(    DEV_ID      ID,             //豸
                            FunInstall  *devUninstall)  //豸бƳ
{
	DEV_ERR err;
	volatile DEV_Handle hDev;

    if (ID < ID_EMPTY)
        return HVL_NO_INVALID;

    if (ID >= ID_MAX_NUM)
        return HVL_NO_INVALID;

    if (devUninstall == NULL)
        return HVL_DRV_INSTALL_NULL;

    API_LOCK();
    for (hDev = 1; hDev < DEV_COUNT; hDev++)        //ѰҶӦ
    {
        if (UdfFramework[hDev].deviceID == ID)
            break;
    }
    
    if (hDev >= DEV_COUNT)
        err = HVL_NO_INVALID;
    else
    {
        UdfFramework[hDev].deviceID = ID_EMPTY;
        UdfFramework[hDev].deviceType = DEV_NONE_type;
        UdfFramework[hDev].canShared = DEV_NONE_share;
        err = (DEV_ERR)(*devUninstall)(&UdfFramework[hDev].op);
    }
    API_UNLOCK();

	return err;
}


#ifdef UCOSIII
static OS_MUTEX DevMutex;        //
static INT32S apiInitFlag = 0;
void APIInit(void)
{
    if (apiInitFlag == 0)
    {   
        OS_ERR err;
        OSMutexCreate(  (OS_MUTEX       *) &DevMutex, 
                        (CPU_CHAR       *)"Mutex Dev",
                        (OS_ERR         *)&err);
        apiInitFlag = 1;
    }
}

void APILock(void)
{
    OS_ERR err;
    CPU_TS ts;
    OSMutexPend(        (OS_MUTEX       *)&DevMutex, 
                        (OS_TICK        )1000, 
                        (OS_OPT         )OS_OPT_PEND_BLOCKING, 
                        (CPU_TS         *)&ts, 
                        (OS_ERR         *)&err);
}

void APIUnlock(void)
{
    OS_ERR err;
    OSMutexPost(        (OS_MUTEX       *)&DevMutex, 
                        (OS_OPT         )OS_OPT_POST_NONE, 
                        (OS_ERR         *)&err);
}

#endif

