/*
********************************************************************************
*                                  uC/OS-III
*								 Ӧýӿڲ
*                              ARM Cortex-M3 Port
*
* File      : API.C
* Version   : V2.0
* By        : ǿ
*
* For       : Cortex-M3
* Mode      : Thumb2
* Toolchain : 
*             RealView Microcontroller Development Kit (MDK)
*             Keil uVision
* 
* 				Ӧòõȫֱṹ塣
********************************************************************************
*/



#ifndef _API_H_
#define _API_H_




#define UCOSIII				//uCosIIIϵͳ
#define MODBUS			    //ʹmodbusЭ

#ifdef UCOSIII
#include "os.h"
#endif

#ifdef MODBUS
#include "MODBUS.h"
#endif

/*
********************************************************************************
*                                              DATA TYPES
*                                         (Compiler Specific)
********************************************************************************
*/

typedef unsigned char		BOOLEAN;
typedef unsigned char		INT8U;      /* Unsigned  8 bit quantity         */
typedef signed char		    INT8S;      /* Signed    8 bit quantity         */
typedef unsigned short		INT16U;     /* Unsigned 16 bit quantity         */
typedef signed short		INT16S;     /* Signed   16 bit quantity         */
typedef unsigned int		INT32U;     /* Unsigned 32 bit quantity         */
typedef signed int			INT32S;     /* Signed   32 bit quantity         */
typedef float				FP32;       /* Single precision floating point  */
typedef double			    FP64;       /* Double precision floating point  */


/******************************************************************************/

#define ENDLESS_LOOP_BREAK(a)   if ((a)++ > 0x800){ a = 0; break;}          //ֹѭ
#define API_COUNTOF(a)          (sizeof(a) / sizeof(*(a)))          //ָ
#define UDF_MAX_NAME            15
#ifndef NULL
#define NULL                    (void *)0
#endif

     
#define CLR                     {0,}                                //ݣڳʼṹ
#define DEV_INDEX(a)            ((short)((a) - ID_EMPTY))           //IDӦбĵǰ
#define DEV_COUNT               (DEV_INDEX(ID_MAX_NUM))             //ܸ
#define DRV_NO_ERR		        HVL_NO_ERR
#define NONE_ERR                HVL_NO_ERR

#ifndef UCOSIII
#define API_LOCK();                         //
#define API_UNLOCK();                       //
#else
#define API_LOCK();             APILock();  //APIʼ
#define API_UNLOCK();           APIUnlock();//APIʽ

#endif
/******************************************************************************/
//UDFCtrl βtoo Ӧб
#define DEV_CTRL_NVIC_Priority  0       //жȼ  Ϊu16
#define DEV_CTRL_ISR_Fun        0x10    //ж϶Ӧ  void Fun(void)

#define DEV_CTRL_DATA_0         0x20    //0     u16
#define DEV_CTRL_DATA_1         0x21    //1     u16
#define DEV_CTRL_DATA_2         0x22    //2     u16
#define DEV_CTRL_DATA_3         0x23    //3     u16
#define DEV_CTRL_DATA_4         0x24    //4     u16
#define DEV_CTRL_DATA_5         0x25    //5     u16
#define DEV_CTRL_DATA_6         0x26    //6     u16
#define DEV_CTRL_DATA_7         0x27    //7     u16
#define DEV_CTRL_DATA_8         0x28    //8     u16
#define DEV_CTRL_DATA_9         0x29    //9     u16

/******************************************************************************/




typedef enum
{
    DEV_NONE_share,     //
    DEV_share,          //ɹ
    DEV_unShare,        //ɹ
}DEV_ShareStatus;

typedef enum
{
    DEV_NONE_type,      //
    DEV_block,          //豸
    DEV_char,           //ַ豸
}DEV_Type;

typedef enum
{   //ڲҪIDǰ "//"
    ID_EMPTY = 0x870,   //ID  
	ID_USART1,
	ID_USART2,
	ID_USART3,
	ID_TIMER3,
	ID_ADC1,
	ID_DAC,
	ID_EEPROM,
	ID_FLASH,
	ID_SPI2,
	ID_SI4432,
	ID_I2C1,
	ID_MPU3050,
	ID_MAX_NUM,         //βID  
}DEV_ID;

typedef enum
{   //Ӳ
	HVL_NO_ERR,             //޴
	HVL_NO_FIN_DEV,         //ûҵ豸
	HVL_NO_INVALID,         //豸Ч
	HVL_NO_HANDLE,          //Ч
	HVL_NO_SHARED,          //豸ɹ
	HVL_OPEND,              //豸Ծ Ӧô 
	HVL_CLOSE,              //ԱʹñرգǻԱʹô豸
	HVL_DRV_OPEN_NULL,      //豸ĴΪ
	HVL_DRV_CLOSE_NULL,     //豸ĹرΪ
	HVL_DRV_WRITE_NULL,     //豸дΪ
	HVL_DRV_READ_NULL,      //豸ĶΪ
	HVL_DRV_CTRL_NULL,      //豸ĿΪ
	HVL_DRV_INSTALL_NULL,    //豸İװΪ
	HVL_DRV_INSTALL_LIST_FULL,  //豸İװб  ޷ٰװ
	HVL_DRV_UNINSTALL_NULL,    //豸İװΪ

	//
	DRV_OPEN_FAIL,          //ʧ
	DRV_CLOSE_FAIL,         //ر쳣
	DRV_WRITE_FAIL,         //дʧ
	DRV_READ_FAIL,          //ʧ
	DRV_READ_BOUNDS,        // Խ
	DRV_CTRL_FAIL,          //ʧ
	DRV_CTRL_NO_FUN,        //޴˿ƹ
}DEV_ERR;

typedef INT32S  DEV_Handle;
typedef INT32S  FunOpen(void *pd);
typedef INT32S  FunRead(INT8S *buffer, INT32U blen, INT32U lenToRead, INT8U type);
typedef INT32S  FunWrite(INT8S *buffer, INT32U lenToWrite, INT8U type);
typedef INT32S  FunIoctl(INT32U too, void *pd);
typedef INT32S  FunClose(void *pd);

typedef struct 
{
	FunOpen     *devOpen;
	FunRead     *devRead;
	FunWrite    *devWrite;
	FunIoctl    *devIoctl;
	FunClose    *devClose;
} UDFOperationsType;
#define UDFOperationsDefault() {    \
	NULL,                           \
	NULL,                           \
	NULL,                           \
	NULL,                           \
	NULL,                           \
}

typedef INT32S  FunInstall(UDFOperationsType *);

typedef struct 
{
	DEV_ID              deviceID;       //豸
	DEV_Type            deviceType;     //DEV_block豸, DEV_charַ豸;
	DEV_ShareStatus     canShared;      //DEV_unShare---ɹʹ, DEV_shareɹʹ
	INT16U              openCount;      //ڹ豸ֶΪ򿪴;
	UDFOperationsType   op;             //豸ģṩ豸
} UDFFrameworkType;
#define UDFFrameworkDefault() { \
	ID_EMPTY,                   \
	DEV_NONE_type,              \
	DEV_NONE_share,             \
	0,                          \
	UDFOperationsDefault(),     \
}





//******************************************************************************
DEV_Handle UDFOpen(     DEV_ID      ID,             //豸
                        void        *pd,            //豸޲ΪNULL
    					DEV_ERR     *err);
    					
DEV_ERR UDFRead(        DEV_Handle  hDev,       //豸
    					INT8S       *buffer,    //׵ַ
    					INT32U      blen,       //
    					INT32U      lenToRead, 	//ȡ
    					INT8U       type);      // ݾ
    					
DEV_ERR UDFWrite(       DEV_Handle  hDev,           //豸
    					INT8S       *buffer, 		//
    					INT32U      lenToWrite, 	//д볤
    					INT8U       type);			// ݾ
    					
DEV_ERR UDFCtrl(        DEV_Handle  hDev, 		//豸
					    INT32U      too, 		//豸  
					    void        *pd	);		//Ʋ οļ
					    
DEV_ERR UDFClose(       DEV_Handle  hDev); 		//豸

DEV_ERR InstallDriver(	DEV_ID              ID,             //豸
						DEV_Type            type,           //0-豸1-ַ豸
						DEV_ShareStatus     shared,         //0-ɹ1-ɹ
						FunInstall         *devInstall);	//豸б


DEV_ERR UninstallDriver(    DEV_ID      ID,                 //豸
                            FunInstall  *devUninstall);     //豸бƳ

void DriverInit(void);                          //ע


#ifdef UCOSIII
void APIInit(void);
void APILock(void);
void APIUnlock(void);

#endif
//***************ȫֱ*******************************************************
extern UDFFrameworkType UdfFramework[DEV_COUNT];




#endif

