#include "DrvI2C.h"

#define uchar unsigned char
 
//PC12ó
#define 	SDA_OUT		do{							    \
							GPIOC->CRH &= 0xFFF0FFFF;	 \
							GPIOC->CRH |= 0x00070000; 	  \
						  }while(0)	
//PC12
#define 	SDA_IN		do{							   \
							GPIOC->CRH &= 0xFFF0FFFF;	\
							GPIOC->CRH |= 0x00080000; 	 \
						  }while(0)			
#define 	SDA 		((GPIOC->IDR&0x1000)>>12)	   
#define   	SDA_0  		GPIOC->BSRR=0x10000000		 //PC12
#define   	SDA_1  		GPIOC->BSRR=0x00001000 		
#define   	SCL_0		GPIOC->BSRR=0x08000000		 //PC11
#define   	SCL_1	 	GPIOC->BSRR=0x00000800  	  

void I2C_IO_init()
{		  
	RCC->APB2ENR|= 1<<4;     //ʹPORTCʱ
	GPIOC->CRH  &= 0xFFF00FFF;//PC11, 12óɿ©	  
	GPIOC->CRH  |= 0x00077000; 
}
/************ʼź*******************/
void start() 
{
	SDA_OUT;	
	SDA_1;
	delay_us(10);
	SCL_1;
	delay_us(10);
	SDA_0;
	delay_us(10);
}
/**************ֹͣ*****************/
void stop()   
{	 
	SDA_OUT;
	SDA_0;
	delay_us(10);
	SCL_1;
	delay_us(10);	
	SDA_1;
	delay_us(10);
}
/**************Ӧ*****************/
void slave_response()  
{
	unsigned short i=0;
	SCL_1;
	while((1==SDA)&&(i<100))i++;
	SCL_0;
	delay_us(10);
}
void host_response()
{
	SCL_0;
	SDA_OUT;
	SDA_0;
	delay_us(10);
	SCL_1;
	delay_us(10);
	SCL_0;
	SDA_1;
}
/**************ʼ*****************/
void init()
{		 
	SDA_OUT;	
	SDA_1;
	delay_us(10);
	SCL_1;
	delay_us(10);
}
/**************д*****************/
void write_byte(uchar data)
{
	uchar i;
	SDA_OUT;

	for(i=0;i<8;i++)
	{
		SCL_0;
	    delay_us(10);
		if((data<<i)&0x80)
			SDA_1;
		else
			SDA_0;
		delay_us(10);
		SCL_1;
		delay_us(10);
	}
	SCL_0;
	SDA_1;	
	SDA_IN;
	delay_us(10);
}
/*******************************/
uchar read_byte()
{
	uchar i,k;
	SCL_0; 
	SDA_OUT;	
	SDA_1;	 
	SDA_IN;
	delay_us(10);
	for(i=0;i<8;i++)
	{
		SCL_1;
		delay_us(10);	
		k=(k<<1)|SDA;
		SCL_0;
		delay_us(10);	
	}
	return k;
}
/**************ʱ*****************/
void delay1(uchar x)
{
	uchar a,b;
	for(a=x;a>0;a--)
	 for(b=100;b>0;b--);
}
/**************addressַдdate*****************/
void write_add(uchar address,uchar date)
{
	start();
	write_byte(0xa0);
	slave_response();
	write_byte(address);
	slave_response();
	write_byte(date);
	slave_response();
	stop();
}
/**************ַΪaddressط*****************/
uchar read_add(uchar address)
{
	uchar date;
	start();
	write_byte(0xa0);
	slave_response();
	write_byte(address);
	slave_response();
	start();
	write_byte(0xa1);
	slave_response();
	date=read_byte();
	stop();
	return date;
}
/**************дbuflength(length<9)ݵʼַΪaddressĵط*****************/
void i2c_pagewrite(uchar *buf, uchar length, uchar address)
{
	uchar i=0;
	start();
	write_byte(0xa0);
	slave_response();
	write_byte(address);
	slave_response();
	while(i<length)
	{
		write_byte(buf[i++]);
		slave_response();
	}
	stop();
}
/**************ʼַΪaddressطlengthݵbuf*****************/
void i2c_pageread(uchar *buf, uchar length, uchar address)
{
	uchar *rbuf=buf;
	start();
	write_byte(0xa0);
	slave_response();
	write_byte(address);
	slave_response();
	start();
	write_byte(0xa1);
	slave_response();
	while(length--)
	{
		*rbuf++=read_byte();
		host_response();
	}
	stop();
}
/*******************************/
void i2c_test()
{
	uchar byte=0, i=0;
	uchar wbuf[8]={0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17};
	uchar rbuf[10]={0};
	init();
	write_add(0x12,0x0f);//ڵַΪ0x12طд0x0f
	printf("writing...\n");
	delay1(100);
	byte=read_add(0x12);//ַΪ0x12ݣ0x0f
	printf("byte=0x%02x\n", byte);
	i2c_pagewrite(wbuf, 8, 0x20);
	printf("page writing...\n");
	delay1(200);
	i2c_pageread(rbuf, 10, 0x20);
	printf("page reading...\n");
	printf("rbuf=");
	while(i<10)
		printf("%02x ", rbuf[i++]);
	printf("\n");
	while(1);
}


