/*
********************************************************************************
*                                  uC/OS-II
*							SI4432ģ
*                              ARM Cortex-M3 Port
*
* File      	: SI4432xDrv.C
* Version   	: V1.0
* By        	: ǿ
*
* For       	: Stm32f10x
* Mode      	: Thumb2
* Toolchain 	: 
*             		RealView Microcontroller Development Kit (MDK)
*             		Keil uVision
* Description   :  STM32F10x
*					ʹģ:	SPIxģ 
*								GPIOⲿж 
*
* 	RF ģĲΪ FSK  433.5MHz 1.2KBPS +/-10PPM, Ƶƫ20KHz ƴ41.2KHz 
*			ʹAFCʹCRC PH + FIFO ģʽ, ͷ룺"swwx", ֣ͬ 0x2d 0xd4	
*					SI4432xOpen
*					SI4432xClose
*					SI4432xWrite
*					SI4432xRead
*					SI4432xIoCtl
*					SI4432xInstall
*					SI4432xNuinstall
* Date          : 2012.06.9
*******************************************************************************/





#include "DrvSI4432.h"

unsigned char tx_test_data[10] = {0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x6d}; 
extern void Delay(volatile INT32U nCount);

#ifdef UCOSIII
//OS_SEM si4432Sem;
extern OS_TCB taskSI4432TCB;
static OS_ERR err;
#endif

INT8U ItStatus1, ItStatus2;

INT8U RxBuf[15] = {0,};
static DEV_Handle _hSPI2;


/*******************************************************************************
* Function Name :static void GpioInit(void) 
* Description   :˿ڳʼ
* Input         :
* Output        :
* Other         :
* Date          :2012.06.20  16:32:55
*******************************************************************************/
static void GpioInit(void) 
{ 
	GPIO_InitTypeDef GPIO_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APBXPeriph_GPIOX, ENABLE);    

	GPIO_InitStructure.GPIO_Pin = GPIOX_PIN_nIRQ;			//оƬж
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOX_nIRQ, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIOX_PIN_SDN;			//оƬλ
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOX_SDN, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIOX_PIN_nSEL;			//оƬʹ
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOX_nSEL, &GPIO_InitStructure);

	GPIO_EXTILineConfig(EXTI_GPIOx, EXTI_GPIOx_PIN);
	ExtiActive(ENABLE);
}	

/*******************************************************************************
* Function Name :static void SI4432Init(void)
* Description   :оƬ óʼ
* Input         :
* Output        :
* Other         :
* Date          :2012.06.20  16:33:13
*******************************************************************************/
static void SI4432Init(void)
{
    DEV_ERR err;
    
	_hSPI2 = UDFOpen(ID_SPI2, NULL, &err);
	
	GpioInit();  				// IO ڳʼ
	ExtiPrioritySet(0x0500);

 	SDN(1);
 	OSTimeDly(		(OS_TICK	)10,		
 					(OS_OPT		)OS_OPT_TIME_DLY,
 					(OS_ERR		*)&err	);	// RF ģϵ縴λ
 	SDN(0);
	OSTimeDly(		(OS_TICK	)200,
 					(OS_OPT		)OS_OPT_TIME_DLY,
 					(OS_ERR		*)&err	);	// ʱ200ms RF ģ빤״̬
 	
#if 1						//
	SpiRw(0x34,0x00);
	SpiRw(0x35,0x00);
	SpiRw(0x36,0x00);
	SpiRw(0x37,0x00);
#endif

	ItStatus1 = SpiRw(0x03,0x00);		// RFģж	
	ItStatus2 = SpiRw(0x04,0x00);
	
	SpiRw(0x06|0x80, 0x00);  //  رղҪж
	
	SpiRw(0x07|0x80, SI4432_PWRSTATE_READY);   //  Ready ģʽ
	 


	SpiRw(0x09|0x80, 0x64);  //  ص= 10p

	SpiRw(0x0a|0x80, 0x05);	// رյƵ
	SpiRw(0x0b|0x80, 0xea); // GPIO 0 ͨ
	SpiRw(0x0c|0x80, 0xea); //GPIO 1 ͨ
	
	SpiRw(0x0d|0x80, 0xf4);  // /GPIO 2 յ
	
	
	
	SpiRw(0x70|0x80, 0x2c);  	// øSilabs Excel
	SpiRw(0x1d|0x80, 0x40);  // ʹ afc
		
	// 1.2K bps setting
	SpiRw(0x1c|0x80, 0x16);	
	
	
	SpiRw(0x20|0x80, 0x83);   
	 
	SpiRw(0x21|0x80, 0xc0); //
	SpiRw(0x22|0x80, 0x13);// 
	SpiRw(0x23|0x80, 0xa9); //
	SpiRw(0x24|0x80, 0x00); //
	SpiRw(0x25|0x80, 0x04); //
	
	SpiRw(0x2a|0x80, 0x14);
	SpiRw(0x6e|0x80, 0x09);
	SpiRw(0x6f|0x80, 0xd5);
	
	// 1.2K bps setting end		
	
	
	SpiRw(0x30|0x80, 0x8c);   // ʹPH+ FIFOģʽλǰ棬ʹCRCУ
 
				
	SpiRw(0x32|0x80, 0xff);  // byte0, 1,2,3 Ϊͷ
 
	SpiRw(0x33|0x80, 0x42);//  byte 0,1,2,3 ͷ룬ͬ3,2 ͬ
	

		
	SpiRw(0x34|0x80, 16);  // 16NibblePreamble
	SpiRw(0x35|0x80, 0x20);  // Ҫ4nibblePreamble
	SpiRw(0x36|0x80, 0x2d);  // ͬΪ 0x2dd4
	SpiRw(0x37|0x80, 0xd4);
	SpiRw(0x38|0x80, 0x00);
	SpiRw(0x39|0x80, 0x00);
	SpiRw(0x3a|0x80, 's');  // ͷΪ swwx"
	SpiRw(0x3b|0x80, 'w');
	SpiRw(0x3c|0x80, 'w');
	SpiRw(0x3d|0x80, 'x');
	SpiRw(0x3e|0x80, 10);  // ܹ10ֽڵ
	SpiRw(0x3f|0x80, 's'); // ҪУͷΪswwx"
	SpiRw(0x40|0x80, 'w');
	SpiRw(0x41|0x80, 'w');
	SpiRw(0x42|0x80, 'x');
	SpiRw(0x43|0x80, 0xff);  // ͷ1,2,3,4 λҪУ
	SpiRw(0x44|0x80, 0xff);  // 
	SpiRw(0x45|0x80, 0xff);  // 
	SpiRw(0x46|0x80, 0xff);  // 
	SpiRw(0x6d|0x80, 0x07);  // Ϊʷ

	SpiRw(0x79|0x80, 0x0);  // ҪƵ
	SpiRw(0x7a|0x80, 0x0);  // ҪƵ
	
	
	SpiRw(0x71|0x80, 0x22); // 䲻Ҫ CLKFiFo  FSKģʽ
			
	SpiRw(0x72|0x80, 0x30);  // ƵƫΪ 30KHz
	

	SpiRw(0x73|0x80, 0x0);  // ûƵƫ
	SpiRw(0x74|0x80, 0x0);  // ûƵƫ
	
	
		
	SpiRw(0x75|0x80, 0x53);  // Ƶ 434
	SpiRw(0x76|0x80, 0x57);  // 
	SpiRw(0x77|0x80, 0x80);
			
	TX0_RX0;				// ޷䣬޽״̬
}

/*******************************************************************************
* Function Name :static void RxData(INT8U *txPr, INT16U len)
* Description   :е
* Input         :
* Output        :
* Other         :
* Date          :2012.06.09  18:13:46
*******************************************************************************/
static void RxData(INT8U *rxPr, INT16U len)
{
	INT16U i;
	
	ItStatus1 = SpiRw(0x03,0x00);	// ж
	ItStatus2 = SpiRw(0x04,0x00);	// ж

	nSEL(0);
	SpiByte(0x7f);				// ӻ
	for(i = 0; i < len; i++)	
	{
		*rxPr++ = SpiByte(0x00);
	}
	*rxPr = '\0';
	nSEL(1);

	SpiRw(0x07|0x80, SI4432_PWRSTATE_READY);	// ݽɣ˳ģʽ
}
  
/*******************************************************************************
* Function Name :static void RxMode(void)		
* Description   :ýģʽ յݰж
* Input         :
* Output        :
* Other         :
* Date          :2012.06.09  17:55:32
*******************************************************************************/
static void RxMode(void)		
{	
	SpiRw(0x07|0x80, SI4432_PWRSTATE_READY);	// Ready ģʽ
	OSTimeDly(		(OS_TICK	)5,
 					(OS_OPT		)OS_OPT_TIME_DLY,
 					(OS_ERR		*)&err	);//

	TX0_RX1;		// ߿
	
	SpiRw(0x08|0x80, 0x03);  //巢䣬ջ
	SpiRw(0x08|0x80, 0x00);  //巢䣬ջ
		
	SpiRw(0x07|0x80,SI4432_PWRSTATE_RX );  // RF ģģʽ
	
	SpiRw(0x05|0x80, SI4432_Rx_packet_received_interrupt);  // RFģյݺ󣬲ж
		
	ItStatus1 = SpiRw(0x03,0x00);		//ежϱ־
	ItStatus2 = SpiRw(0x04,0x00);		//ежϱ־
		
}	

/*******************************************************************************
* Function Name :static void TxData(void)
* Description   :һ
* Input         :*txPr:׵ַlen:ݳȣ60ֽ
* Output        :
* Other         :
* Date          :2012.06.09  17:57:20
*******************************************************************************/
static void TxData(INT8U *txPr, INT16U len)
{
	INT8U i;
	static INT16U lostCount = 0;

	SpiRw(0x07|0x80, SI4432_PWRSTATE_READY);	// rf ģReady ģʽ

	TX1_RX0;		//߿صķ
	
	OSTimeDly(		(OS_TICK	)5,			// RF ģϵ縴λ
 					(OS_OPT		)OS_OPT_TIME_DLY,
 					(OS_ERR		*)&err	);		// ʱ 5ms, ϵͳȶ
	
	SpiRw(0x08|0x80, 0x03);  // 
	SpiRw(0x08|0x80, 0x00);  // 巢䣬ջ
		
	SpiRw(0x34|0x80, 40);  // 40Nibble ǰ
	SpiRw(0x3e|0x80, 10);  // ܹ10ֽڵ
  	for (i = 0; i<len; i++)
	{
		SpiRw(0x7f|0x80, *(txPr + i)); 	// Ҫ뻺
	}
	SpiRw(0x05|0x80, SI4432_PACKET_SENT_INTERRUPT);	// ݷ󣬲ж
	ItStatus1 = SpiRw(0x03,0x00);		// RFģж	
	ItStatus2 = SpiRw(0x04,0x00);
	SpiRw(0x07|0x80, SI4432_PWRSTATE_TX);  // 뷢ģʽ
	
	OSTaskSemPend((OS_TICK	)500, 
					(OS_OPT		)OS_OPT_PEND_BLOCKING,
					(CPU_TS		*)0,
					(OS_ERR		*)&err	);		// ȴж ȴ0.5s
	if(err == OS_ERR_TIMEOUT)
	{
		lostCount++;
		if (lostCount >= 3)
		{
			//0.5 * 4뻹ûж,RFģ鹤¸λʼģ
			SI4432Init();
			lostCount = 0;
		}
	}
	else if(err == OS_ERR_NONE)	//
		lostCount = 0;

  	RxMode();		//rf ɣģʽ
}	

/*******************************************************************************
* Function Name :static INT8U SpiByte(INT8U data)
* Description   :һֽ
* Input         :
* Output        :
* Other         :
* Date          :2012.06.09  18:23:03
*******************************************************************************/
static INT8U SpiByte(INT8U data)
{
	INT8U val;
	
	UDFWrite(_hSPI2, (INT8S *)&data, 1, 0);
	UDFRead(_hSPI2, (INT8S *)&val, 1, 1, 0);

	return val;
}

/*******************************************************************************
* Function Name :static INT8U SpiRw(INT8U addr, INT8U data)
* Description   :ָ
* Input         :
* Output        :
* Other         :
* Date          :2012.06.09  18:23:16
*******************************************************************************/
static INT8U SpiRw(INT8U addr, INT8U data)
{
	INT8U val;
	
	nSEL(0);							//ʹ si4432оƬ
	UDFWrite(_hSPI2, (INT8S *)&addr, 1, 0);
	UDFWrite(_hSPI2, (INT8S *)&data, 1, 0);
	nSEL(1);							//ʧ si4432оƬ
	UDFRead(_hSPI2, (INT8S *)&val, 1, 1, 0);

	return val;
}

static void ExtiActive(FunctionalState cmd)
{
	EXTI_InitTypeDef EXTI_InitStructure;
		/* Configure Button EXTI line */
	EXTI_InitStructure.EXTI_Line = EXTI_Linex;
	EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;  
	EXTI_InitStructure.EXTI_LineCmd = cmd;
	EXTI_Init(&EXTI_InitStructure);
}

/*******************************************************************************
* Function Name :static void ExtiPrioritySet(INT16U level)
* Description   :жȼ
* Input         :level:8λ Ϊռȼ8λǴȼ
* Output        :
* Other         :
* Date          :2012.06.09  17:39:11
*******************************************************************************/
static void ExtiPrioritySet(INT16U level)
{
	NVIC_InitTypeDef NvicInitdef;

	NvicInitdef.NVIC_IRQChannel = EXTIxIRQChannel;
	NvicInitdef.NVIC_IRQChannelPreemptionPriority = level >> 8;
	NvicInitdef.NVIC_IRQChannelSubPriority = level & 0xFF;
	NvicInitdef.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init( &NvicInitdef );

}



/*******************************************************************************
* Function Name :static INT32S SI4432xOpen(void *pd)
* Description   :оƬSI4432ʼ
* Input         :Ч
* Output        :
* Other         :
* Date          :2012.05.28  16:17:21
*******************************************************************************/
static INT32S SI4432xOpen(void *pd)
{
	SI4432Init();
	ExtiPrioritySet(0x0400);		//ĬȼΪ4ռ
	return (INT32S)DRV_NO_ERR;
}


/*******************************************************************************
* Function Name :static INT32S SI4432xClose(void *pd)
* Description   :ʧоƬ
* Input         :
* Output        :
* Other         :
* Date          :2012.05.28  16:18:25
*******************************************************************************/
static INT32S SI4432xClose(void *pd)
{	
	ExtiActive(DISABLE);
	return (INT32S)DRV_NO_ERR;
}


/*******************************************************************************
* Function Name :static INT32S SI4432xWrite(INT8S *buffer, INT32U lenToWrite, INT8U waitType)
* Description   :һ֡
* Input         :buffer:ҪдݡlenToWriter:ݳ(ֽ)
* Output        :
* Other         :
* Date          :2012.05.28  16:18:46
*******************************************************************************/
static INT32S SI4432xWrite(INT8S *buffer, INT32U lenToWrite, INT8U waitType)
{
	TxData((INT8U *)buffer, lenToWrite);
	return (INT32S)DRV_NO_ERR;
}

/*******************************************************************************
* Function Name :static INT32S SI4432xRead(INT8S *buffer, INT32U blen, INT32U lenToRead, INT8U waitType)
* Description   :һ֡
* Input         :buffer:ݻlenToRead:ȡĳ(UDFCtrl 0x01ȡ)
* Output        :
* Other         :
* Date          :2012.05.28  16:19:26
*******************************************************************************/
static INT32S SI4432xRead(INT8S *buffer, INT32U blen, INT32U lenToRead, INT8U waitType)
{	
	RxData((INT8U *)buffer, lenToRead);
	return (INT32S)DRV_NO_ERR;
}


/*******************************************************************************
* Function Name :static INT32S SI4432xIoCtl(INT32U too, void *pd)
* Description   :оƬ
* Input         :too		*pd
* 				 0			int16 жȼ8λռȼ8λȼ :int16
* 				 0x11		int16 ȡݳ
* Output        :
* Other         :
* Date          :2012.06.09  18:29:13
*******************************************************************************/
static INT32S SI4432xIoCtl(INT32U too, void *pd)
{
	switch (too)
	{
		case 0: ExtiPrioritySet(*(INT16U *)pd); break;
		case 1: *(INT16U *)pd = SpiRw(0x4B,0x00); break;			//յ
		default: break;
	}
	return (INT32S)DRV_NO_ERR;
}


INT32S SI4432xInstall(UDFOperationsType *op)
{
	op->devOpen = SI4432xOpen;
	op->devClose = SI4432xClose;
	op->devWrite = SI4432xWrite;
	op->devRead = SI4432xRead;
	op->devIoctl = SI4432xIoCtl;
	
	return (INT32S)DRV_NO_ERR;
}


INT32S SI4432xNuinstall(UDFOperationsType *op)
{
	INT32S res = (INT32S)DRV_NO_ERR;
	void *pd = NULL;
	
	if (op->devClose != NULL)
		res = op->devClose(pd);
	op->devOpen = NULL;
	op->devClose = NULL;
	op->devWrite = NULL;
	op->devRead = NULL;
	op->devIoctl = NULL;

	return res;
}




/*******************************************************************************
* Function Name :void EXTIxIRQHandler(void)
* Description   :յһ֡ݰ жϺ
* Input         :
* Output        :
* Other         :
* Date          :2012.06.09  17:38:10
*******************************************************************************/
void EXTIxIRQHandler(void)
{
	OSIntEnter();
	
	if(EXTI_GetITStatus(EXTI_Linex) != RESET)
	{				
		OSTaskSemPost(	(OS_TCB		*)&taskSI4432TCB, 
						(OS_OPT		)OS_OPT_POST_NO_SCHED, 
						(OS_ERR 	*)&err	);
	}

	EXTI_ClearITPendingBit(EXTI_Linex);	// Clear the Key Button EXTI line pending bit
	OSIntExit();
}



void OSSi4432Seriver(void)
{ 
	INT16U len;	
	DEV_ERR err;
	DEV_Handle hSI4432;
	extern DEV_Handle _hUsart1;
 	hSI4432 = UDFOpen(ID_SI4432, NULL, &err);// RF ģʼ	
	while(1)
	{		
		// ÿһʱ䣬һݣ Acknowledge ź
		UDFWrite(ID_SI4432, (INT8S 	*)tx_test_data, sizeof(tx_test_data), 0);
		OSTaskSemPend((OS_TICK	)1000, 
						(OS_OPT		)OS_OPT_PEND_BLOCKING,
						(CPU_TS		*)0,
						(OS_ERR		*)&err	);
						
		if (err == OS_ERR_NONE)
		{
			UDFCtrl(hSI4432, 1, (void *)&len);		//ݳ
			UDFRead(hSI4432,  (INT8S *)RxBuf, sizeof(RxBuf), len, 0);//	
			UDFWrite(_hUsart1, (INT8S *)RxBuf, strlen((const char *)RxBuf), 0);
		}	
		
		OSTimeDly(		(OS_TICK 	)1000, 
						(OS_OPT		)OS_OPT_TIME_DLY, 
						(OS_ERR 	*)&err	);
	}	
}



