#ifndef _DrvSI4432_h_
#define _DrvSI4432_h_

#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_exti.h"
#include "misc.h"

#include "Api.h"
#include <string.h>
#include <math.h>

/*----------------------------------------------------------------------------*/

#define RCC_APBXPeriph_GPIOX_nIRQ	RCC_APB2Periph_GPIOC//
#define RCC_APBXPeriph_GPIOX_nSEL	RCC_APB2Periph_GPIOC//
#define RCC_APBXPeriph_GPIOX_SDN	RCC_APB2Periph_GPIOC//

#define GPIOX_nIRQ			GPIOC
#define GPIOX_nSEL			GPIOC
#define GPIOX_SDN				GPIOC

#define GPIOX_PIN_nIRQ		GPIO_Pin_9				//оƬж
#define GPIOX_PIN_nSEL		GPIO_Pin_8				//оƬʹ
#define GPIOX_PIN_SDN			GPIO_Pin_7				//оƬλ

#define EXTI_Linex			EXTI_Line9
#define EXTI_GPIOx			GPIO_PortSourceGPIOC
#define EXTI_GPIOx_PIN	 	GPIO_PinSource9

#define EXTIxIRQHandler		EXTI9_5_IRQHandler
#define EXTIxIRQChannel		EXTI9_5_IRQn			//жϺͨ

#define SI4432xInstall		SI4432Install
#define SI4432xNuinstall		SI4432Nuinstall

/*----------------------------------------------------------------------------*/


#define RCC_APBXPeriph_GPIOX		(RCC_APBXPeriph_GPIOX_nIRQ |\
									RCC_APBXPeriph_GPIOX_nSEL |\
									RCC_APBXPeriph_GPIOX_SDN )

#define nSEL(a)		{(a) == 0? GPIO_ResetBits(GPIOX_nSEL, GPIOX_PIN_nSEL) :\
								GPIO_SetBits(GPIOX_nSEL, GPIOX_PIN_nSEL);}	
#define SDN(a)		{(a) == 0? GPIO_ResetBits(GPIOX_SDN, GPIOX_PIN_SDN) :\
								GPIO_SetBits(GPIOX_SDN, GPIOX_PIN_SDN);}	


#define SI4432_PWRSTATE_READY			01			// ģ Ready ״̬
#define SI4432_PWRSTATE_TX				0x09		// ģ ״̬
#define SI4432_PWRSTATE_RX				05			// ģ ״̬
#define SI4432_PACKET_SENT_INTERRUPT	04			// ģ ж
#define SI4432_Rx_packet_received_interrupt   0x02      // ģ յݰж


#define  TX1_RX0		SpiRw(0x0e|0x80, 0x01)			// ״̬߿ض
#define  TX0_RX1		SpiRw(0x0e|0x80, 0x02)			// ״̬߿ض
#define  TX0_RX0		SpiRw(0x0e|0x80, 0x00)       		// Ƿ䣬״̬߿ض






/******************************************************************************/
static void RxData(INT8U *rxPr, INT16U len);
static void TxData(INT8U *txPr, INT16U len);
static void RxMode(void);

static INT8U SpiByte(INT8U data);
static INT8U SpiRw(INT8U addr, INT8U data);
static void SI4432Init(void);
static void GpioInit(void); 

static void ExtiActive(FunctionalState cmd);
static void ExtiPrioritySet(INT16U level);


/*******************************************************************************
* Description   :оƬSI4432ʼ
* Input         :Ч
*******************************************************************************/
static INT32S SI4432xOpen(void *pd);
/*******************************************************************************
* Description   :ʧоƬ
*******************************************************************************/
static INT32S SI4432xClose(void *pd);
/*******************************************************************************
* Description   :һ֡
* Input         :buffer:ҪдݡlenToWriter:ݳ(ֽ)
*******************************************************************************/
static INT32S SI4432xWrite(INT8S *buffer, INT32U lenToWrite, INT8U waitType);
/*******************************************************************************
* Description   :һ֡
* Input         :buffer:ݻlenToRead:ȡĳ(UDFCtrl 0x01ȡ)
*******************************************************************************/
static INT32S SI4432xRead(INT8S *buffer, INT32U blen, INT32U lenToRead, INT8U waitType);
/*******************************************************************************
* Description   :оƬ
* Input         :too		*pd
* 				 0			int16 жȼ8λռȼ8λȼ :int16
* 				 0x11		int16 ȡݳ
*******************************************************************************/
static INT32S SI4432xIoCtl(INT32U too, void *pd);



INT32S SI4432xInstall(UDFOperationsType *op);
INT32S SI4432xNuinstall(UDFOperationsType *op);

#endif


