/*
********************************************************************************
*                                  uC/OS-II
*							   SPI
*                              ARM Cortex-M3 Port
*
* File      	: DrvSPI2.C
* Version   	: V1.0
* By        	: ǿ
*
* For       	: Stm32f10x
* Mode      	: Thumb2
* Toolchain 	: 
*             		RealView Microcontroller Development Kit (MDK)
*             		Keil uVision
* Description   : STM32F10x ڲSPI 
*					ռSPIx(SPI1,SPI2)
*				
*					SPIxOpen
*					SPIxClose
*					SPIxWrite
*					SPIxRead
*					SPIxIoCtl
*					SPIxInstall
*					SPIxNuinstall
* Date          : 2012.06.3
*******************************************************************************/

#include "DrvSPI2.h"

//static volatile INT8U receiveFlag = 0;
//static void (* SpiIRQHandler)(void) = NULL;

//#ifdef UCOSII
//
//static OS_EVENT *spiSem;
//static INT8U spiSemErr;
//#endif

/*******************************************************************************
* Function Name :static void SPIxInit(void)
* Description   :ڳʼ
* Input         :
* Output        :
* Other         :
* Date          :2011.06.01  12:47:08
*******************************************************************************/
static void SPIxInit(void)
{
	SPI_InitTypeDef SPI_InitStructure;
	GPIO_InitTypeDef GPIO_InitStructure;

	/* Enable peripheral clocks --------------------------------------------------*/
	/* GPIOA, GPIOB and SPI1 clock enable */
	RCC_APB2PeriphClockCmd(RCC_APBXPeriph_GPIOX, ENABLE);
	
	/* SPI2 Periph clock enable */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);	//SPI1,2ͬҪֶĶ

	
	GPIO_InitStructure.GPIO_Pin = GPIOX_PIN_MISO;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOX_MISO, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIOX_PIN_MOSI;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOX_MOSI, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIOX_PIN_CLK;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOX_CLK, &GPIO_InitStructure);

	GPIO_SetBits(GPIOX_MISO, GPIOX_PIN_MISO);
	GPIO_SetBits(GPIOX_MOSI, GPIOX_PIN_MOSI);
	GPIO_SetBits(GPIOX_CLK, GPIOX_PIN_CLK);


	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;		//ȫ˫
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_8;
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
	SPI_InitStructure.SPI_CRCPolynomial = 7;
	SPI_Init(SPIx, &SPI_InitStructure);
	
//	SPI_I2S_ITConfig(SPIx, SPI_I2S_IT_TXE, DISABLE);
//	SPI_I2S_ITConfig(SPIx, SPI_I2S_IT_RXNE, DISABLE);

	SPI_Cmd(SPIx, ENABLE);
	
//#ifdef UCOSII
//	spiSem = OSSemCreate(0);
//#endif
}

/*******************************************************************************
* Function Name :static void SPIxPrioritySet(INT16U level)
* Description   :SPIжϵȼ趨
* Input         :level:8λ Ϊռȼ8λǴȼ
* Output        :
* Other         :
* Date          :2012.05.28  10:09:37
*******************************************************************************/
static void SPIxPrioritySet(INT16U level)
{
	NVIC_InitTypeDef NvicInitdef;

	NvicInitdef.NVIC_IRQChannel = SPIx_IRQChannel;
	NvicInitdef.NVIC_IRQChannelPreemptionPriority = level >> 8;
	NvicInitdef.NVIC_IRQChannelSubPriority = level & 0xFF;
	NvicInitdef.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init( &NvicInitdef );
}


/*******************************************************************************
* Function Name :static INT32S SPIxOpen(void *pd)
* Description   :SPIʼ SPI
* Input         :Ч
* Output        :
* Other         :
* Date          :2012.05.23  10:25:06
*******************************************************************************/
static INT32S SPIxOpen(void *pd)
{
	SPIxInit();
//	SPIxPrioritySet(0x0400);
	return (INT32S)DRV_NO_ERR;
}

/*******************************************************************************
* Function Name :static INT32S SPIxClose(void *pd)
* Description   :ʧܴ
* Input         :
* Output        :
* Other         :
* Date          :2012.05.24  09:10:25
*******************************************************************************/
static INT32S SPIxClose(void *pd)
{	
	SPI_Cmd(SPIx, DISABLE);
	return (INT32S)DRV_NO_ERR;
}

/*******************************************************************************
* Function Name :static INT32S SPIxWrite(INT8S *buffer, INT32U lenToWrite, INT8U waitType)
* Description   :*buffer:塣lenToWrite:ݵĳ(ֽ)
* Input         :
* Output        :
* Other         :
* Date          :2012.05.23  14:19:47
*******************************************************************************/
static INT32S SPIxWrite(INT8S *buffer, INT32U lenToWrite, INT8U waitType)
{
	while (lenToWrite--)
	{	
		//ͻΪ
		while (SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_TXE) == RESET);		
		SPI_I2S_SendData(SPIx, *buffer++);

		while ((SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_RXNE) == RESET));
		SPI_I2S_ReceiveData(SPIx);
	}
	
	return (INT32S)DRV_NO_ERR;
}

/*******************************************************************************
* Function Name :static INT32S SPIxRead(INT8S *buffer, INT32U blen, INT32U lenToRead, INT8U waitType)
* Description   :ȡ
* Input         :*buffer:塣lenToRead:ݵĳ(ֽ)
* Output        :
* Other         :
* Date          :2012.05.23  14:19:49
*******************************************************************************/
static INT32S SPIxRead(INT8S *buffer, INT32U blen, INT32U lenToRead, INT8U waitType)
{	
	*buffer = SPI_I2S_ReceiveData(SPIx);
	
	return (INT32S)DRV_NO_ERR;
}

/*******************************************************************************
* Function Name :static INT32S SPIxIoCtl(INT32U too, void *pd)
* Description   :SPIX
* Input         :too: 	*pd
*				 0		INT16U	жȼ8λռȼ8λȼ
*				 0x10	void (*)(void)͵жϺ
* Output        :
* Other         :
* Date          :2012.05.23  14:19:51
*******************************************************************************/
static INT32S SPIxIoCtl(INT32U too, void *pd)
{
	switch (too)
	{
		case 0 : SPIxPrioritySet(*(INT16U *)pd); break;
//		case 0x10 : SpiIRQHandler = (void (*)(void))pd; break;
		default : break;
	}
	
	return (INT32S)DRV_NO_ERR;
}
/*******************************************************************************
* Function Name :INT32S SPIxInstall(UDFOperationsType *op)
* Description   :װSPIx
* Input         :
* Output        :
* Other         :
* Date          :2012.05.13
*******************************************************************************/
INT32S SPIxInstall(UDFOperationsType *op)
{
	op->devOpen = SPIxOpen;
	op->devClose = SPIxClose;
	op->devWrite = SPIxWrite;
	op->devRead = SPIxRead;
	op->devIoctl = SPIxIoCtl;
	
	return (INT32S)DRV_NO_ERR;
}

/*******************************************************************************
* Function Name :INT32S SPIxNuinstall(UDFOperationsType *op)
* Description   :жSPIx
* Input         :
* Output        :
* Other         :
* Date          :2012.05.13
*******************************************************************************/
INT32S SPIxNuinstall(UDFOperationsType *op)
{
	INT32S res = (INT32S)DRV_NO_ERR;
	void *pd = NULL;
	
	if (op->devClose != NULL)
		res = op->devClose(pd);
	op->devOpen = NULL;
	op->devClose = NULL;
	op->devWrite = NULL;
	op->devRead = NULL;
	op->devIoctl = NULL;

	return res;
}

/*******************************************************************************
* Function Name :void SPI_IRQHandler(void)
* Description   :SPIжϺ
* Input         :
* Output        :
* Other         :
* Date          :2012.05.24  14:49:49
*******************************************************************************/
void SPIx_IRQHandler(void)
{
#ifdef UCOSIII
	OSIntEnter();
#endif

#ifdef UCOSIII
	OSIntExit();
#endif
}


/********************** END ***************************************************/

