/*
********************************************************************************
*                                  uC/OS-II
*								ʱ
*                              ARM Cortex-M3 Port
*
* File      	: DrvTime3.C
* Version   	: V1.0
* By        	: ǿ
*
* For       	: Stm32f10x
* Mode      	: Thumb2
* Toolchain 	: 
*             		RealView Microcontroller Development Kit (MDK)
*             		Keil uVision
* Description   : ʱ  ռöʱʱpwm 4·ͨ(Ҫѡ)
*					TimXOpen
*					TimXClose
*					TimXWrite
*					TimXRead
*					TimXIoCtl
*					TimXInstall
*					TimXNuinstall
* Date          : 2012.05.22
*******************************************************************************/



#include "DrvTime3.h"

static volatile u16 timConst = 0;
static void (*IRQHandler)(void) = NULL;

/*******************************************************************************
* Function Name :static void BspTimXInit(u16 freq)
* Description   :ͨöʱ ʼ
* Input         :
* Output        :
* Other         :
* Date          :2012.06.16  23:08:26
*******************************************************************************/
static void BspTimXInit(u32 freq)
{
	TIM_TimeBaseInitTypeDef timbase;
	TIM_OCInitTypeDef ocinitdef;
	GPIO_InitTypeDef GpioInitdef;
	u16 prescaler = 1;

	if (freq == 0) freq = 1;		//ݴ
	while((7.2e7 / freq / prescaler) > 0xFFFF) prescaler *= 2;		//ѡԤƵֵ
	timConst = (u16)(7.2e7 / freq / prescaler);

	RCC_APB1PeriphClockCmd(RCC_APBXPeriph_TIMX, ENABLE);	

	timbase.TIM_Prescaler = prescaler - 1;
	timbase.TIM_ClockDivision = TIM_CKD_DIV1;
	timbase.TIM_Period = timConst - 1;	
	timbase.TIM_CounterMode = TIM_CounterMode_Up;
	TIM_TimeBaseInit(TIMX, &timbase);

#if (TIMX_PWM_CC1_EN + TIMX_PWM_CC2_EN)		//ͨ12pwm
	RCC_APB2PeriphClockCmd(RCC_APBXPeriph_GPIOX_1 | RCC_APB2Periph_AFIO, ENABLE);    

	prescaler = 0;
#if TIMX_PWM_CC1_EN
	prescaler = TIMX_GPIOX_PIN_CC1;
#endif

#if TIMX_PWM_CC2_EN
	prescaler |= TIMX_GPIOX_PIN_CC2;
#endif

	GpioInitdef.GPIO_Pin = prescaler;
	GpioInitdef.GPIO_Speed = GPIO_Speed_50MHz;
	GpioInitdef.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(TIMX_GPIOX_1, &GpioInitdef );//PWM ˿

	/* PWM1 Mode configuration: Channel1 */
	ocinitdef.TIM_OCMode = TIM_OCMode_PWMX;
	ocinitdef.TIM_OCPolarity = TIM_OCPolarity_H_L;
	ocinitdef.TIM_OutputState = TIM_OutputState_Enable;
	ocinitdef.TIM_Pulse = 0;
	
#if TIMX_PWM_CC1_EN
	TIM_OC1Init(TIMX, &ocinitdef);
	TIM_OC1PreloadConfig(TIMX, TIM_OCPreload_Enable);
#endif

#if TIMX_PWM_CC2_EN
	TIM_OC2Init(TIMX, &ocinitdef);
	TIM_OC2PreloadConfig(TIMX, TIM_OCPreload_Enable);
#endif

#endif



#if (TIMX_PWM_CC3_EN + TIMX_PWM_CC4_EN)		//ͨ34pwm
	RCC_APB2PeriphClockCmd(RCC_APBXPeriph_GPIOX_2 | RCC_APB2Periph_AFIO, ENABLE);	 

	prescaler = 0;
#if TIMX_PWM_CC3_EN
	prescaler = TIMX_GPIOX_PIN_CC3;
#endif

#if TIMX_PWM_CC4_EN
	prescaler |= TIMX_GPIOX_PIN_CC4;
#endif

	GpioInitdef.GPIO_Pin = prescaler;
	GpioInitdef.GPIO_Speed = GPIO_Speed_50MHz;
	GpioInitdef.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init( TIMX_GPIOX_2, &GpioInitdef );//PWM ˿

	/* PWM1 Mode configuration: Channel1 */
	ocinitdef.TIM_OCMode = TIM_OCMode_PWMX;
	ocinitdef.TIM_OCPolarity = TIM_OCPolarity_H_L;
	ocinitdef.TIM_OutputState = TIM_OutputState_Enable;
	ocinitdef.TIM_Pulse = 0;
#if TIMX_PWM_CC3_EN
	TIM_OC3Init(TIMX, &ocinitdef);
	TIM_OC3PreloadConfig(TIMX, TIM_OCPreload_Enable);
#endif

#if TIMX_PWM_CC4_EN
	TIM_OC4Init(TIMX, &ocinitdef);
	TIM_OC4PreloadConfig(TIMX, TIM_OCPreload_Enable);
#endif

#endif

	TIM_ARRPreloadConfig(TIMX, ENABLE);
	
#if TIMX_INTERRUPT_EN
	TIM_ITConfig(TIMX, TIM_IT_Update, ENABLE);
#endif

}

/*******************************************************************************
* Function Name :static void BspTimXPrioritySet(u16 level)
* Description   :ʱжϵȼ趨
* Input         :level:8λ Ϊռȼ8λǴȼ
* Output        :
* Other         :
* Date          :2012.05.28  10:09:37
*******************************************************************************/
static void BspTimXPrioritySet(u16 level)
{
	NVIC_InitTypeDef NvicInitdef;

	NvicInitdef.NVIC_IRQChannel = TIMX_IRQChannel;
	NvicInitdef.NVIC_IRQChannelPreemptionPriority = level >> 8;
	NvicInitdef.NVIC_IRQChannelSubPriority = level & 0xFF;
	NvicInitdef.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init( &NvicInitdef );
}


/*******************************************************************************
* Function Name :s32 TimXOpen(void *pd)
* Description   :ʹtimXʱ
* Input         :*pd Ƶ u32
* Output        :
* Other         :
* Date          :2012.05.22  14:14:40
*******************************************************************************/
static s32 TimXOpen(void *pd)
{
	BspTimXInit(*(u32 *)pd);		//TIM3ģʼ
	/* TIMX enable counter */
	TIM_Cmd(TIMX, ENABLE);

	return DRV_NO_ERR;
}

/*******************************************************************************
* Function Name :s32 TimXClose(void *pd)
* Description   :timXʱ
* Input         :
* Output        :
* Other         :
* Date          :2012.05.22  15:25:36
*******************************************************************************/
static s32 TimXClose(void *pd)
{
	TIM_Cmd(TIMX, DISABLE);
//	IRQHandler = NULL;
	
	return (s32)DRV_NO_ERR;
}



/*******************************************************************************
* Function Name :static s32 TimXIoCtl(u32 too, void *pd)
* Description   :timXʱ ռձȿ
* Input         :too:1-ͨ12-ͨ23-ͨ34-ͨ4.
				 too		                *pd
				 DEV_CTRL_NVIC_Priority	    жȼ8λռȼ8λȼ :int16
				 DEV_CTRL_DATA_1			ͨ1ռձȡλ() ȡֵΧ:0-1000  :int16
				 DEV_CTRL_DATA_2			ͨ2ռձȡλ() ȡֵΧ:0-1000  :int16
				 DEV_CTRL_DATA_3			ͨ3ռձȡλ() ȡֵΧ:0-1000  :int16
				 DEV_CTRL_DATA_4			ͨ4ռձȡλ() ȡֵΧ:0-1000  :int16
 				 DEV_CTRL_ISR_Fun		    жϷ  void(*)(void)
				
* Output        :ȡֵ  Чָ 
* Other         :
* Date          :2012.05.22  17:46:04
*                2012.11.9޸ģtoo:ֵк궨ָ
*******************************************************************************/
static s32 TimXIoCtl(u32 too, void *pd)
{
	//ֵܼ ǧֱ
	u16 cnt = *(u16 *)pd;
	
#if TIMX_PWM_EN
	//PWMռձ  Χ ش
	if (cnt > 1000) return (s32)DRV_CTRL_FAIL;	
	cnt = (u16)(timConst * cnt / 1000);	//ǰļֵ1000ȷ*cnt ĵձ
#endif

	switch (too)
	{
		case DEV_CTRL_NVIC_Priority: BspTimXPrioritySet(*(u16 *)pd); break;

#if TIMX_PWM_CC1_EN
		case DEV_CTRL_DATA_1: TIM_SetCompare1(TIMX, cnt); break;
#endif

#if TIMX_PWM_CC2_EN
		case DEV_CTRL_DATA_2: TIM_SetCompare2(TIMX, cnt); break;
#endif

#if TIMX_PWM_CC3_EN
		case DEV_CTRL_DATA_3: TIM_SetCompare3(TIMX, cnt); break;
#endif

#if TIMX_PWM_CC4_EN
		case DEV_CTRL_DATA_4: TIM_SetCompare4(TIMX, cnt); break;
#endif

#if TIMX_INTERRUPT_EN
		case DEV_CTRL_ISR_Fun: IRQHandler = (void (*)(void))pd; break;
#endif
		default : return (s32)DRV_CTRL_NO_FUN;
	}
	return (s32)DRV_NO_ERR;
}

/*******************************************************************************
* Function Name :s32 TimXInstall(UDFOperationsType *op)
* Description   :װTimx
* Input         :
* Output        :
* Other         :
* Date          :2012.05.11  13:46:55
*******************************************************************************/
s32 TimXInstall(UDFOperationsType *op)
{
	op->devOpen = TimXOpen;
	op->devClose = TimXClose;
	op->devWrite = NULL;
	op->devRead = NULL;
	op->devIoctl = TimXIoCtl;
	
	return (s32)DRV_NO_ERR;
}

/*******************************************************************************
* Function Name :s32 TimXNuinstall(UDFOperationsType *op)
* Description   :жTimx
* Input         :
* Output        :
* Other         :
* Date          :2012.05.11  13:47:32
*******************************************************************************/
s32 TimXNuinstall(UDFOperationsType *op)
{
	s32 res = (s32)DRV_NO_ERR;
	void *pd = NULL;
	
	if (op->devClose != NULL)
		res = op->devClose(pd);
	op->devOpen = NULL;
	op->devClose = NULL;
	op->devWrite = NULL;
	op->devRead = NULL;
	op->devIoctl = NULL;

	return res;
}

/*******************************************************************************
* Function Name :void TIMX_IRQHandler( void )
* Description   :timxжϺ
* Input         :
* Output        :
* Other         :
* Date          :2012.05.22  16:10:06
*******************************************************************************/
void TIMX_IRQHandler(void)
{
#ifdef UCOSII
	OSIntEnter();
#endif
	if( SET == TIM_GetITStatus(TIMX,TIM_IT_Update) )
	{
		TIM_ClearITPendingBit( TIMX, TIM_IT_Update);
		if (IRQHandler != NULL)(*IRQHandler)();			//жϺ
	}
#ifdef UCOSII
	OSIntExit();
#endif
}


/********************** END ***************************************************/

