/*
********************************************************************************
*                                  uC/OS-II
*								
*                              ARM Cortex-M3 Port
*
* File      	: DrvUsart1.C
* Version   	: V1.0
* By        	: ǿ
*
* For       	: Stm32f10x
* Mode      	: Thumb2
* Toolchain 	: 
*             		RealView Microcontroller Development Kit (MDK)
*             		Keil uVision
* Description   : 	
					ռ ڼ˿TX,RX(궨趨)
					RS485 Ҫѡ(궨ѡ)
					RS485 ˿ѡ(궨)

* Date          : 2012.05.14    
                    2012.9.11޸ģַҪⲿ궨#deine RECEIVE_CHAR
*******************************************************************************/



#include "DrvUsart1.h"


#ifdef MODBUS		//ʹmodbusЭ º
extern void ReceOneChar(u8 ReceCharacter);
void (*receChar)(u8 ch) = (void (*)(u8))ReceOneChar;
#else
void (*receChar)(u8 ch) = NULL;
#endif


SerialBuffType sendBuff = SerialBuffDefault();
SerialBuffType receiveBuff = SerialBuffDefault();
static SerialBuffType *sb = &sendBuff;
static SerialBuffType *rb = &receiveBuff;
static SerialType serialParam = SerialDefault();


#ifdef RS485
/*******************************************************************************
* Function Name :void BspRS485Init(void)
* Description   :RS485 շƶ˿ ʼ
* Input         :
* Output        :
* Other         :
* Date          :2012.05.21  15:45:40
*******************************************************************************/
static void BspRS485Init(void)
{
	GPIO_InitTypeDef GpioInitdef;

	RCC_APB2PeriphClockCmd(RS_485_APB, ENABLE);

	GpioInitdef.GPIO_Pin = RS_485_PIN; //
	GpioInitdef.GPIO_Speed = GPIO_Speed_50MHz;
	GpioInitdef.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(RS_485_GPIOX, &GpioInitdef);

	RS_485_R();
}
	
#endif

/*******************************************************************************
* Function Name :u32 BspSerialGetBaud(u32 baud)
* Description   :ضӦĲ
* Input         :ǰϵͳ洢Ĳ
* Output        :
* Other         :
* Date          :2012.05.07  17:40:17
*******************************************************************************/
static u32 BspSerialGetBaud(u16 baud)
{
	u32 res;

	switch (baud)
	{
		case 24:
		case 48: 
		case 96: 
		case 192: 
		case 384: 
		case 430: 
		case 560: 
		case 576: 
        case 1152: res = baud * 100; break;
		default : res = 38400; break;
	}
	
	return res;
}

/*******************************************************************************
* Function Name :u16 BspSerialGetStop(float val)
* Description   :ضӦֹͣλ
* Input         :ϵͳ洢ֹͣλ
* Output        :
* Other         :
* Date          :2012.05.08  09:55:56
*******************************************************************************/
static u16 BspSerialGetStop(u8 val)
{
	u16 res;
	
	switch (val)
	{
		case 1: res = USART_StopBits_1; break;
		case 2: res = USART_StopBits_2; break;
		default : res = USART_StopBits_1; break;
	}

	return res;
}

/*******************************************************************************
* Function Name :u16 bspSerialGetParity(u32 val)
* Description   :ȡӦУ鷽
* Input         :ϵͳ洢ĶӦУ 0:  1:棬2:ż
* Output        :
* Other         :
* Date          :2012.05.08  09:56:55
*******************************************************************************/
static u16 bspSerialGetParity(u8 val)
{
	u16 res;
	switch (val)
	{
		case 0: res = USART_Parity_No; break;
		case 1: res = USART_Parity_Odd; break;
		case 2: res = USART_Parity_Even; break;
		default : res = USART_Parity_No; break;
	}
	return res;
}


/*******************************************************************************
* Function Name :s32 BspUsartxInit(SerialType *sp)
* Description   :ڼųʼ
* Input         :ڲ
* Output        :ִ״̬
* Other         :
* Date          :2012.05.11  11:41:47
*******************************************************************************/
static s32 BspUsartxInit(SerialType *sp)
{
	GPIO_InitTypeDef GpioInitdef;
	USART_InitTypeDef UsartInitdef;
    assert_param(RECEIVE_CHAR);
    
	if (sp == NULL)
	    sp = &serialParam;
	RCC_APB2PeriphClockCmd(RCC_APBXPeriph_GPIOX | RCC_APBXPeriph_USARTX, ENABLE);  

	USART_DeInit(USARTX);
//	USART_SetPrescaler(USARTX, 0x18);		//usartx ԤƵ
	USART_StructInit( &UsartInitdef );
	UsartInitdef.USART_BaudRate = BspSerialGetBaud(sp->baud);
	UsartInitdef.USART_StopBits = BspSerialGetStop(sp->stop);
	UsartInitdef.USART_WordLength = USART_WordLength_8b;
	UsartInitdef.USART_Parity = bspSerialGetParity(sp->parity);

	UsartInitdef.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USARTX, &UsartInitdef);
	
	GpioInitdef.GPIO_Pin = USARTX_GPIOX_PIN_TX; //
	GpioInitdef.GPIO_Speed = GPIO_Speed_10MHz;
	GpioInitdef.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(USARTX_GPIOX, &GpioInitdef);

	GpioInitdef.GPIO_Pin = USARTX_GPIOX_PIN_RX; //
	GpioInitdef.GPIO_Speed = GPIO_Speed_10MHz;
	GpioInitdef.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(USARTX_GPIOX, &GpioInitdef);

	USART_ITConfig(USARTX, USART_IT_TXE, ENABLE);
	USART_ITConfig(USARTX, USART_IT_RXNE, ENABLE);
	
#ifdef RS485
	BspRS485Init();
#endif

	return DRV_NO_ERR;
}


/*******************************************************************************
* Function Name :static void BspUsartPrioritySet(int16 level)
* Description   :ȼ
* Input         :level:8λǰռȼ8λǴȼ
* Output        :
* Other         :
* Date          :2012.05.24  17:22:04
*******************************************************************************/
static void BspUsartPrioritySet(u16 level)
{
	NVIC_InitTypeDef NvicInitdef;

	NvicInitdef.NVIC_IRQChannel = USARTX_IRQChannel;
	NvicInitdef.NVIC_IRQChannelPreemptionPriority = level >> 8;
	NvicInitdef.NVIC_IRQChannelSubPriority = level & 0xFF;
	NvicInitdef.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init( &NvicInitdef );
}


/*******************************************************************************
* Function Name :s32 BspUsartSend(u8* buf, u32 len)
* Description   :һַ
* Input         :*buf:ַָ롣len:
* Output        :ִ״̬  DRV_NO_ERR:޴
* Other         :
* Date          :2012.05.11  11:45:38
*******************************************************************************/
static s32 BspUsartSend(s8 *buf, u32 len)
{
	s32 res = (s32)DRV_WRITE_FAIL;	//Ծ
	
    if (sb->len)    //ݣûз
        return DRV_WRITE_FAIL;

    if (len <= 0)    //͵Ϊ
        return DRV_WRITE_FAIL;

    if (len > USARTX_BUFF_LANGTH)  //Ҫ͵ BUFF
        return DRV_WRITE_FAIL;

    if (USART_GetITStatus(USARTX, USART_IT_TXE) == ENABLE) //ûȫɵ
        return DRV_WRITE_FAIL;

    if (USART_GetITStatus(USARTX, USART_IT_TC) == ENABLE)
        return DRV_WRITE_FAIL;
         
#ifdef RS485
	RS_485_S();
#endif

	sb->len = len - 1;
	sb->ind = 0;
	memcpy(sb->buf, buf + 1, len - 1);
	USART_SendData(USARTX, *buf);
	USART_ITConfig(USARTX, USART_IT_TXE, ENABLE);    

	res = (s32)DRV_NO_ERR;	//޴

	return res;
}

/*******************************************************************************
* Function Name :static s32 BspUsartReceive(u8* buf, u32 len)
* Description   :ȡջе
* Input         :
* Output        :
* Other         :
* Date          :2012.05.11  13:31:01
*******************************************************************************/
static s32 BspUsartReceive(s8 *buf, u32 len)
{
	s32 res = (s32)DRV_READ_FAIL;	//Ծ
	if ((rb->ind > 0) && (len > 0) && (len <= USARTX_BUFF_LANGTH))
	{
	    if (rb->ind < len)
	    {
	        u16 tmp = len - rb->ind;
	        memcpy(buf, &(rb->buf)[USARTX_BUFF_LANGTH - tmp - 1], tmp);
	        memcpy(buf + tmp, rb->buf, rb->ind);
	    }
	    else
		    memcpy(buf, rb->buf + rb->ind - len, len);
		memset(rb, 0x00, USARTX_BUFF_LANGTH);
		res = (s32)DRV_NO_ERR;	//޴
	}

	return res;
}


/*******************************************************************************
* Function Name :s32 UsartXOpen(void *pd)
* Description   :򿪴 ʼ
* Input         :*pd:ṹ崮ڲ
* Output        :
* Other         :
* Date          :2012.05.22  14:14:40
*******************************************************************************/
static s32 UsartXOpen(void *pd)
{
    assert_param(USARTX_Priority);
    
	BspUsartxInit((SerialType *)pd);
	USART_Cmd(USARTX, ENABLE);
	BspUsartPrioritySet(USARTX_Priority);
	
	return DRV_NO_ERR;
}

/*******************************************************************************
* Function Name :s32 UsartXClose(void *pd)
* Description   :Usartx
* Input         :
* Output        :
* Other         :
* Date          :2012.06.16  23:42:07
*******************************************************************************/
static s32 UsartXClose(void *pd)
{
	USART_Cmd(USARTX, DISABLE);
	return DRV_NO_ERR;
}

/*******************************************************************************
* Function Name :s32 UsartXWrite(s8 *buffer, u32 lenToWrite, u8 waitType)
* Description   :һַ
* Input         :buffer:ַ  lenToWrite:Ҫصĳ
* Output        :
* Other         :
* Date          :2012.06.16  23:42:10
*******************************************************************************/
static s32 UsartXWrite(s8 *buffer, u32 lenToWrite, u8 waitType)
{
	return BspUsartSend(buffer, lenToWrite);
}

/*******************************************************************************
* Function Name :s32 UsartXRead(s8 *buffer, u32 blen, u32 lenToRead, u8 waitType)
* Description   :еַ
* Input         :buffer:شŵ׵ַ
* Output        :
* Other         :
* Date          :2012.06.16  23:42:12
*******************************************************************************/
static s32 UsartXRead(s8 *buffer, u32 blen, u32 lenToRead, u8 waitType)
{
	return BspUsartReceive(buffer, lenToRead);
}

/*******************************************************************************
* Function Name :s32 UsartXIoCtl(u32 too, void *pd)
* Description   :ڿ
* Input         :too		*pd
* 				 0 			int16  8λռȣ8λ  ȼ 
* 				 0x11		int16  еĳȡ
* Output        :
* Other         :
* Date          :2012.05.24  17:25:17
*******************************************************************************/
static s32 UsartXIoCtl(u32 too, void *pd)
{
	switch (too)
	{
		case 0: BspUsartPrioritySet(*(u16 *)pd); 	break;
		case 0x11: *(u16 *)pd = rb->ind;			break;
		default : break;
	}
	return 0;
}

/*******************************************************************************
* Function Name :s32 UsartXInstall(UDFOperationsType *op)
* Description   :װusartX
* Input         :
* Output        :
* Other         :
* Date          :2012.05.11  13:46:55
*******************************************************************************/
s32 UsartXInstall(UDFOperationsType *op)
{
	op->devOpen = UsartXOpen;
	op->devClose = UsartXClose;
	op->devWrite = UsartXWrite;
	op->devRead = UsartXRead;
	op->devIoctl = UsartXIoCtl;
	
	return (s32)DRV_NO_ERR;
}

/*******************************************************************************
* Function Name :s32 UsartXNuinstall(UDFOperationsType *op)
* Description   :жusartX
* Input         :
* Output        :
* Other         :
* Date          :2012.05.11  13:47:32
*******************************************************************************/
s32 UsartXNuinstall(UDFOperationsType *op)
{
	s32 res = (s32)DRV_NO_ERR;
	void *pd = NULL;
	
	if (op->devClose != NULL)
		res = op->devClose(pd);
	op->devOpen = NULL;
	op->devClose = NULL;
	op->devWrite = NULL;
	op->devRead = NULL;
	op->devIoctl = NULL;

	return res;
}

/*******************************************************************************
* Function Name :void USARTX_IRQHandler(void)
* Description   :USARTX жϳ
* Input         :
* Output        :
* Other         :
* Date          :2011.11.16  16:57:39
*******************************************************************************/
void USARTX_IRQHandler(void)
{
#ifdef UCOSIII
	OSIntEnter();
#endif	
	if( SET == USART_GetITStatus(USARTX, USART_IT_TXE) )
	{
		USART_ClearITPendingBit( USARTX, USART_IT_TXE );
		if(sb->len > 0 )
		{
			USART_SendData( USARTX, sb->buf[sb->ind++] );
			sb->len--;
		}
		else
		{
			USART_ITConfig( USARTX, USART_IT_TXE, DISABLE );
			USART_ITConfig( USARTX, USART_IT_TC, ENABLE );
		}
	}
	else if( USART_GetITStatus(USARTX, USART_IT_TC) != RESET )
	{
		USART_ClearITPendingBit( USARTX, USART_IT_TC );
		USART_ITConfig( USARTX, USART_IT_TC, DISABLE );
		sb->len = 0;
#ifdef RS485
		RS_485_R();
#endif

	}
	else if( USART_GetITStatus(USARTX, USART_IT_RXNE) != RESET )
	{
		u8 ch;
		
		USART_ClearITPendingBit( USARTX, USART_IT_RXNE );	
		ch = USART_ReceiveData(USARTX);
		
		rb->buf[rb->ind++] = ch;
		if (rb->ind >= USARTX_BUFF_LANGTH) rb->ind = 0;	//Χ

        if (receChar)
		    (*receChar)(ch);
	}	
#ifdef UCOSIII
	OSIntExit();
#endif
}



/********************** END ***************************************************/


