#ifndef _DrvUsart1_h_
#define _DrvUsart1_h_

#include "stm32f10x_usart.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "misc.h"
#include "Api.h"
#include <string.h>



/*-----------------------------ֲĶ-----------------------------------*/


//#define RS485			//ʹ485 д˿


#define USARTX                  USART3
#define RCC_APBXPeriph_GPIOX    RCC_APB2Periph_GPIOB
#define RCC_APBXPeriph_USARTX   RCC_APB1Periph_USART3
#define USARTX_GPIOX            GPIOB
#define USARTX_GPIOX_PIN_RX     GPIO_Pin_11
#define USARTX_GPIOX_PIN_TX     GPIO_Pin_10
#define USARTX_IRQHandler       USART3_IRQHandler
#define USARTX_IRQChannel       USART3_IRQn

#ifdef RS485
#define RS_485_PIN              GPIO_Pin_1
#define RS_485_GPIOX            GPIOB
#define RS_485_APB              RCC_APB2Periph_GPIOB
#define RS_485_S()              GPIO_SetBits(RS_485_GPIOX, RS_485_PIN)		// 485ʹ
#define RS_485_R()              GPIO_ResetBits(RS_485_GPIOX, RS_485_PIN)		// 485ʹ
#endif

#define UsartXInstall           Usart3Install
#define UsartXNuinstall         Usart3Nuinstall

extern void ReceOneCharCh2(u8 ch);
#define RECEIVE_CHAR            ReceOneCharCh2          //1ַ
#define USARTX_Priority         0x0000                  //ȼ
/*----------------------------------------------------------------------------*/


#define USARTX_BUFF_LANGTH      155


typedef struct	
{
	INT8U node;			//ڵ
	INT8U protocol;		//Эģʽ 0:modbus 1:NMEA	
	INT16U baud;			//
	INT8U parity;			//żУ 
	INT8U stop;			//ֹͣλ
	INT8U *requestPtr;	// ָ֡
}SerialType;
#define SerialDefault() {\
	100,\
	1,\
	48,\
	0,\
	1,\
	NULL,\
}

typedef struct {
	INT8U buf[USARTX_BUFF_LANGTH];
	INT32U len;
	INT8U ind;
}SerialBuffType;		//ݴ
#define SerialBuffDefault() {\
	{0,},\
	0,\
	0,\
}

/*----------------------------------------------------------------------------*/




/*******************************************************************************
* Function Name :s32 UsartXOpen(void *pd)
* Description   :򿪴 ʼ
* Input         :*pd:ṹ崮ڲ
*******************************************************************************/
static s32 UsartXOpen(void *pd);
/*******************************************************************************
* Function Name :s32 UsartXClose(void *pd)
* Description   :Usartx
*******************************************************************************/
static s32 UsartXClose(void *pd);
/*******************************************************************************
* Function Name :s32 UsartXWrite(s8 *buffer, u32 lenToWrite, u8 waitType)
* Description   :һַ
* Input         :buffer:ַ  lenToWrite:Ҫصĳ
*******************************************************************************/
static s32 UsartXWrite(s8 *buffer, u32 lenToWrite, u8 waitType);
/*******************************************************************************
* Function Name :s32 UsartXRead(s8 *buffer, u32 blen, u32 lenToRead, u8 waitType)
* Description   :еַ
* Input         :buffer:شŵ׵ַ
*******************************************************************************/
static s32 UsartXRead(s8 *buffer, u32 blen, u32 lenToRead, u8 waitType);
/*******************************************************************************
* Function Name :s32 UsartXIoCtl(u32 too, void *pd)
* Description   :ڿ
* Input         :too		*pd
* 				 0 			16λݣ8λռȣ8λ  ȼ 
* 				 0x11		int16  еĳȡ
*******************************************************************************/
static s32 UsartXIoCtl(u32 too, void *pd);


extern SerialType UsartXPara;

INT32S UsartXInstall(UDFOperationsType *op);
INT32S UsartXNuinstall(UDFOperationsType *op);



#endif


